/*--------------------------------------------------------*
 *  SCREEN.H                                              *
 *  C-1990 Manfred Birnkott                               *
 *--------------------------------------------------------*/
/*--------------------------------------------------------*
 *  Bildschirm-Attribut zusammensetzen                    *
 *--------------------------------------------------------*/
#define ATTR(fc,bc)              ((int)(fc)|((int)(bc)<<4))
/*--------------------------------------------------------*
 *  Zeichen-Modi setzen                                   *
 *--------------------------------------------------------*/
#define crosslinemode(mode)      CROSSLINEMODE=mode
#define windowmode(mode)         WINDOWMODE=mode
#define shadowmode(mode)         SHADOWMODE=mode
/*--------------------------------------------------------*
 *  Zeichen-Attribute setzen                              *
 *--------------------------------------------------------*/
#define textlineattr(attr)       TEXTLINEATTR=attr
#define shadowattr(attr)         SHADOWATTR=attr
/*--------------------------------------------------------*
 *  Linienstile setzen                                    *
 *--------------------------------------------------------*/
#define framelinestyle(style)    FRAMELINESTYLE=style
#define textlinestyle(style)     TEXTLINESTYLE=style
/*--------------------------------------------------------*
 *  vertikale/horizontale Linie zeichnen (Textmodus)      *
 *--------------------------------------------------------*/
#define drawvline(x,y1,y2)       drawline(x,y1,x,y2)
#define drawhline(y,x1,x2)       drawline(x1,y,x2,y)
/*--------------------------------------------------------*
 *  Prototypen                                            *
 *--------------------------------------------------------*/
void drawline    (int x1, int y1, int x2, int y2);
void drawpolygon (int anz, signed char *coord);
void drawframe   (int x1, int y1, int x2, int y2);
void windowframe (void);
/*--------------------------------------------------------*
 *  Konstanten                                            *
 *--------------------------------------------------------*/
#define LINESTYLE_1  "ĳ"
#define LINESTYLE_2  "ͺ"
#define LINESTYLE_3  "ͳ"
#define LINESTYLE_4  "ĺ"
#define FRAMESTYLE_1  "Ŀ"
#define FRAMESTYLE_2  "ͻȺ"
#define FRAMESTYLE_3  "͸Գ"
#define FRAMESTYLE_4  "ķӺ"
/*--------------------------------------------------------*
 *  Steuer-Gren                                         *
 *--------------------------------------------------------*/
int  CROSSLINEMODE=1;
int  WINDOWMODE=0;
int  SHADOWMODE=0;
int  TEXTLINEATTR=0x71;  /* ATTR(BLUE,LIGHTGRAY)  */
int  SHADOWATTR=0x07;    /* ATTR(LIGHTGRAY,BLACK) */
unsigned char *FRAMELINESTYLE=FRAMESTYLE_1;
unsigned char *TEXTLINESTYLE=LINESTYLE_1;
