(* ------------------------------------------------------ *)
(*                     MAKECHAR.PAS                       *)
(*    Hilfsprogramm zum Erzeugen der Datei ZSATZ.INC      *)
(*             (c) 1990 Gerd Arnold & TOOLBOX             *)
(* ------------------------------------------------------ *)

PROGRAM ZeichenSatz;

USES Graph, Crt;

VAR ch           : CHAR;
    Gd, Gm, x, y : INTEGER;
    Wert         : BYTE;
    WertStr      : STRING[3];
    Datei        : TEXT;

CONST
    Bits: ARRAY[0..7] OF BYTE =
          (128, 64, 32, 16, 8, 4, 2, 1);

BEGIN
  DetectGraph(Gd, Gm);
  InitGraph(Gd, Gm, '');
  SetTextStyle(DefaultFont, HorizDir, 1);       { 8x8-Font }
  SetTextJustify(LeftText, TopText);
  SetColor(1);
  Assign(Datei, 'ZSATZ.INC');
  Rewrite(Datei);
  FOR ch := #0 TO #255 DO BEGIN
    OutTextXY(0, 0, ch);              { Zeichen auf Screen }
    Write(Datei, '  {#', Ord(ch):3, '} (');
    IF ch = #0 THEN Write(Datei, '(');
    FOR y := 0 TO 7 DO BEGIN
      Wert := 0;
      FOR x := 0 TO 7 DO
        IF GetPixel(x, y) = 1 THEN
          Wert := Wert OR Bits[x];      { Zeichen codieren }
      Str(Wert, WertStr);
      Write(Datei, WertStr);              { Zahl schreiben }
      IF y < 7 THEN Write(Datei, ', ');
    END;
    IF ch < #255 THEN Writeln(Datei, '),')
    ELSE Writeln(Datei, '));');
    ClearDevice;
  END;
  Close(Datei);
  RestoreCrtMode;
END.
(* ------------------------------------------------------ *)
(*                 Ende von MAKECHAR.PAS                  *)
