/*****************************************************************************
**   ANSI.H                                                                 **
*****************************************************************************/

/* Dies ist ein Header-File mit Makros zur Bildschirmsteuerung. */

/* Fuer die korrekte Funktion muss der ANSI-Treiber in das System inte-     */
/* integriert sein. (Aufruf "DEVICE=ANSI.SYS" in der CONFIG.SYS-Datei) */


#define SETCR(y,x)   printf("\x1B[%d;%df", y+1, x+1)          /* x = 1 bis 80 */
#define ZEIG(y,x,str) printf("\x1B[%d;%df%s", y+1, x+1, str)  /* y = 1 bis 25 */
#define ZEIGZ(y,x,c)  printf("\x1B[%d;%df%c", y+1, x+1, c)    /* y = 1 bis 25 */
#define UP          cputs("\x1B[1A")         /* Cursor eine Zeile aufwaerts */
#define DN          cputs("\x1B[1B")           /* Cursor eine Zeil abwaerts */
#define FW          cputs("\x1B[1C")        /* Cursor eine Spalte vorwaerts */
#define BW          cputs("\x1B[1d")      /* Cursor eine Spalte rueckwaerts */

#define STO         cputs("\x1B[s")            /* Cursor-Position speichern */
#define RCL         cputs("\x1B[u")         /* Cursor-Position wieder laden */

#define CLS         printf("\x1B[2J")                   /* Bildschirm loeschen   */
#define CLRLINE(z)  printf("\x1B[%d;1f\x1B[K",z+1)      /* Zeile lschen         */
#define CLREOL(z,s) printf("\x1B[%d;%df\x1B[K",z+1,s+1) /* Zeile ab Pos. lschen */

/* Darstellungs-Modus fuer Textausgabe einstellen */

#define NORM        cputs("\x1B[0m")                 /* Normale Darstellung */
#define INTS        cputs("\x1B[1m")                   /* Helle Darstellung */
#define BLNK        cputs("\x1B[5m")               /* Blinkende Darstellung */
#define INVS        cputs("\x1B[7m")                 /* Inverse Darstellung */

#define SCHWARZ   0
#define BLAU      1
#define GRUEN     2
#define TUERKIS   3
#define ROT       4
#define LILA      5
#define BRAUN     6
#define WEISS     7

#define ULN         cputs("\x1B[4m")          /* Unterstrichene Darstellung */
                                            /* (nur monochrome Bildschirme) */

#define SETFARBE(vor, hin) printf("\x1B[%dm\x1B[%dm",vor+30,hin+40)
