/*	inspglin.c
Dieses File enthlt alle Funktionen um mit Programmzeilen einzu-
fgen und wieder zu lschen.
(c) 1990 Michael Beising & TOOLBOX
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "interp.h"

/* lokale Funktionsprototypen */

/* Bentigte Globalvariable */
extern	PRGZEILE	*FirstLine;		/* erste Interpreterzeile */
extern	PRGZEILE	*LastLine;		/* letzte Interpreterzeile */
extern	PRGZEILE	*ActLine;		/* aktuelle interpretierte Zeile */
extern	char		*LinePos;		/* Zeilenposition der aktuellen Zeile*/

/* InsIntLine: Programmzeile in Programmtext einfgen
*/

void
InsIntLine ()	
{
PRGZEILE	*NewLine;
PRGZEILE	*InsZeile;

	/* Speicherplatz fr neue Zeile reservieren */
	NewLine = (PRGZEILE *)malloc (sizeof(PRGZEILE));
	if (NewLine == NULL) {
	  printf ("\n### Kein Speicherplatz mehr vorhanden! ");
	  return;
	}

	/* Handelt es sich um die erste Zeile, dann fge direkt ein. */
	if (!FirstLine) {
	  FirstLine = NewLine;
	  NewLine->LineNumber = ActLine->LineNumber;
	  strcpy (NewLine->Zeile,ActLine->Zeile);
	  NewLine->NextZeile = NULL;
	  NewLine->PrevZeile = NULL;
	  return;
	}
	
	if (FindInsPos(ActLine->LineNumber,&InsZeile)) {
		/* Kopiere den neuen Inhalt ber die alte Zeile */
		strcpy (InsZeile->Zeile,ActLine->Zeile);
		free (NewLine);					/* Speicher nicht bentigt */
	}
	else {
	      /* Neue Zeile in Gefge einhngen. */
		NewLine->LineNumber = ActLine->LineNumber;
		strcpy (NewLine->Zeile,ActLine->Zeile);
			/* Es gibt noch keine Zeile => erste Zeile */
		if ((InsZeile == FirstLine) &&
		    (InsZeile->LineNumber < NewLine->LineNumber)) {
		  NewLine->NextZeile = NULL;
		  NewLine->PrevZeile = InsZeile;
		  InsZeile->NextZeile = NewLine;
		  return;		
		}
		
		if (InsZeile->NextZeile) { /* Zeile richtig einfgen */
		  NewLine->NextZeile  = InsZeile;		
		  NewLine->PrevZeile  = InsZeile->PrevZeile;
		
		  if (InsZeile->PrevZeile)
			InsZeile->PrevZeile->NextZeile = NewLine;
		  else
			FirstLine = NewLine;
		  InsZeile->PrevZeile = NewLine;
		}
		else {	/* Zeile am Ende einfgen */
		  NewLine->NextZeile = NULL;
		  NewLine->PrevZeile = InsZeile;
		  InsZeile->NextZeile = NewLine;
		}
	}
}

/*FindInsPos: wenn es die Zeile schon gibt,
gibt "FindInsPos" als Ergebnis TRUE zurck, ansonsten FALSE
*/

int
FindInsPos (LineNumber,InsPos)
int		LineNumber;
PRGZEILE	**InsPos;
{
PRGZEILE	*FindZeile,*LastLine;

	FindZeile = FirstLine;

	while ((FindZeile != NULL) &&
	       (FindZeile->LineNumber < LineNumber)) {
	  LastLine = FindZeile;
	  FindZeile = FindZeile->NextZeile;
	}
	if (!FindZeile)
	  FindZeile = LastLine;

	if (FindZeile->LineNumber == LineNumber) {
	  *InsPos = FindZeile;
	  return (TRUE);
	}
	else {
	  *InsPos =  FindZeile;
	  return (FALSE);
	}
}


/*	DelLine
	Lscht die Zeile mit der angegebenen Zeilennummer, wenn sie vor-
	handen ist.
*/

int
DelLine (LineNumber)
int		LineNumber ;
{
PRGZEILE	*InsPos;

	  /* Wenn die Zeile vorhanden ist, mu sie ausgehngt werden. */
	if (FindInsPos (LineNumber,&InsPos)) {
	  if ((InsPos->NextZeile == NULL) &&
	      (InsPos->PrevZeile == NULL))
	    FirstLine = NULL;
	  else
		if (InsPos == FirstLine) {
		    FirstLine = InsPos->NextZeile;
		    InsPos->NextZeile->PrevZeile = NULL;
		}
		else {
		  if (InsPos->NextZeile == NULL)
		    InsPos->PrevZeile->NextZeile = NULL;
		  else {
		      InsPos->PrevZeile->NextZeile = InsPos->NextZeile;
		      InsPos->NextZeile->PrevZeile = InsPos->PrevZeile;
		  }
	    }
	  free (InsPos);		/* Speicherplatz wieder freigeben.		*/
	  return (TRUE);		/* Zeile konnte gelscht werden.		*/
	}
	else
	  return (FALSE);		/* Zeile konnte nicht gelscht werden.	*/	
}

/* Ende des Files INSPGLIN.C */
