(* ------------------------------------------------------ *)
(*                    BGI2BIN.PAS                         *)
(* Borland Graphics Interface to                          *)
(*                            Binary Code File Converter  *)
(*                                                        *)
(* Konvertierungsprogramm, um aus einer BGI-Datei         *)
(* eine Binr-Code-Datei zu erzeugen, die sich dann       *)
(* einfacher mit einem Debugger oder (noch besser) einem  *)
(* Disassembler analysieren lt.                         *)
(*                                                        *)
(* Die Kopierroutine entspricht teilweise dem             *)
(* Programmbeispiel im amerikanischen Handbuch            *)
(* zur Routine "BlockRead" (Version 4.0: Owner's          *)
(* Handbook, Seite 381; Version 5.0: Reference Guide,     *)
(* Seite 231).                                            *)
(*      (c) 1991 Hanno-Ekkehard Mller & TOOLBOX          *)
(* ------------------------------------------------------ *)
PROGRAM BGI2BIN;

CONST
  BGIName = 'CGA';

VAR
  fr,fw        : FILE;
  buff         : ARRAY [1..1024] OF BYTE;
  ch           : CHAR;
  nr, nw,
  BGICodeStart : WORD;

BEGIN
  Assign(fr, BGIName + '.BGI');
  Reset(fr, 1);
  REPEAT
    BlockRead(fr, ch, SizeOf(CHAR));
  UNTIL ch = #$1A;
  BlockRead(fr, BGICodeStart, SizeOf(WORD));
  Seek(fr, BGICodeStart);
  Assign(fw, BGIName + '.BIN');
  Rewrite(fw, 1);
  REPEAT
    BlockRead(fr, buff, SizeOf(buff), nr);
    BlockWrite(fw, buff, nr, nw);
  UNTIL nr = 0;
  Close(fw);
  Close(fr);
END.
(* ------------------------------------------------------ *)
(*                Ende von BGI2BIN.PAS                    *)