(* ------------------------------------------------------ *)
(*                    GRAFBIOS.PAS                        *)
(*  Einfaches Demo: Ansteuerung der Grafikkarte via BIOS  *)
(*                 Turbo Pascal ab 5.0                    *)
(* ------------------------------------------------------ *)

PROGRAM GrafBIOS;

USES Crt, Dos;

VAR
  Modus : BYTE;
  x, y : INTEGER;

PROCEDURE SetPixel(x, y : INTEGER; Color : BYTE);
VAR          { einzelnen Punkt in der Farbe "Color" setzen }
  Regs: Registers;
BEGIN
  WITH Regs DO BEGIN
    AH := $0C;
    CX := x;
    DX := y;
    AL := Color;
    Intr($10, Regs);
  END;
END;

PROCEDURE SetMode(Nr : BYTE);
VAR                                   { Grafikmodus setzen }
  Regs: Registers;
BEGIN
  WITH Regs DO BEGIN
    AH := $00;
    AL := Modus;
    Intr($10, Regs);
  END;
END;

BEGIN
  Write('Bitte geben Sie den gewnschten 256-Farben-Modus' +
        ' laut Handbuch ein: ');
  ReadLn(Modus);
  SetMode(Modus);
  FOR x := 1 TO 100 DO
    FOR y := 1 TO 100 DO
      SetPixel(x, y, x + y MOD 256);
  REPEAT UNTIL ReadKey > '';
  TextMode(CO80);    { zurck in Textmodus 80 x 25 Zeichen }
END.

(* ------------------------------------------------------ *)
(*                Ende von GRAFBIOS.PAS                   *)
