(* ------------------------------------------------------ *)
(*                   PINGBALL.PAS                         *)
(*                 Turbo Pascal ab 5.5                    *)
(*           (c) 1991 Ralf Hensmann & TOOLBOX             *)
(* ------------------------------------------------------ *)

PROGRAM PingBall;
{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,R-,S-,V-,X+}
{$DEFINE BGILINK}

(* Der Schalter "BGILINK" setzt die bedingte Compilierung fr das
   Einlinken der BGI-Treiber und des Triplex-Vektorfonts. Wenn Sie
   von dieser Mglichkeit Gebrauch machen mchten, mssen Sie die
   Units "Drivers" und "Fonts" compilieren, die zum Lieferumfang
   von Turbo Pascal gehren. Genauere Informationen ber das Linken
   des Grafikpakets und der Zeichenstz finden Sie in den Quellcodes
   der beiden Units. Bitte beachten Sie, da das Einbinden der
   Treiber und des Vektorfonts die Gre des EXE-Files um zirka
   30 kByte aufblht!

   Wenn der Schalter "BGILINK" nicht gesetzt ist (lschen Sie dazu
   einfach die Zeile "{$DEFINE BGILINK}"), wird das Grafikpaket
   auf herkmmliche Art und Weise installiert. Bitte beachten Sie,
   da "InitGraph" die BGI-Treiber und Vektorfonts in dem Verzeichnis
   sucht, da mittels der Umgebungsvariable "BGIPATH" definiert ist.
   Um diesen Pfad zu definieren, geben Sie ihn einfach auf der
   Kommandozeile an:
   SET BGIPATH = {PFAD}

   Beispiel:
   SET BGIPATH = C:\TP\BGI

   Wenn das Programm keine entsprechende  Variable im Umgebungsbereich
   findet, sucht es die Treiber im aktuellen Verzeichnis. *)

USES  Graph,Crt,
{$IFDEF BGILINK}
      Drivers,Fonts,
{$ENDIF}
      Dos;

CONST FMaxX   = 15; BMaxX = 2*FMaxX+1;
      FMaxY   =  9; BMaxY = 2*FMaxY+1;
      SprMax  =  8;
      MStep   =  3;
      MaxTime = 40000;
      Wall    : FillPatternType = ($DF,$DF,$DF,$00,
                                   $FD,$FD,$FD,$00);
      Title   = 'PingBall';
      Copy    = '(c) ''91 R. Hensmann & toolbox';

TYPE  IntArray = ARRAY [0..4] OF INTEGER;
      TField   = ARRAY [0..FMaxY,0..FMaxX] OF CHAR;
      TLev     = RECORD
                   Back       : ARRAY [1..50] OF TField;
                   Sty,Cx,Cy  : ARRAY [1..50] OF INTEGER;
                 END;
      TRahmen  = RECORD
                   ix,iy,ax,ay : INTEGER;
                 END;
      TBreite  = RECORD
                   x,y : INTEGER;
                 END;

CONST StCol : IntArray = (12,2,4,6,14);
      StBW  : IntArray = (1,1,1,1,1);
      StPat : IntArray = (4,6,8,9,11);

VAR S           : TField;
    F,M,T       : TRahmen;      { Feld, Muster, Zeit }
    Fx,Fy,Bx,By : INTEGER;       { Feldbr., Ballpos. }
    Sc          : PointType;   { Score-Pos., Ballbr. }
    ScB,ScX,ScY : INTEGER;{ Bstb-br., Graph-Ballpos. }
    TLine       : LONGINT;     { aktuelle Zeit-Zeile }
    Time,TCheck : LONGINT;  { Zeit, nchste nderung }
    CCount,Klk  : INTEGER;   { Zhler,Klick-Variable }
    Score,Speed,
    Level,Style : INTEGER;       { Programmvariablen }
    DZahl,FZahl : INTEGER;  { Anz. Diamanten, Steine }
    MoveF,ClrO  : CHAR;  { Felder, die funktionieren }
    DelF,HMoveF,
    LMoveF      : CHAR;
    Page        : BYTE;             { aktuelle Seite }
    Dead        : BOOLEAN;           { Spieler tot ? }
    Lev         : TLev;
    FLevel      : FILE OF TLev;

    {************ Zeiger fr Image-Sprites **********}
    CM          : ARRAY [#0..#255]    OF Pointer;
    BallM       : ARRAY [-MStep..MStep,
                         -MStep..MStep] OF Pointer;
    SprX,SprY   : ARRAY [0..SprMax] OF INTEGER;
    ScoreM      : ARRAY ['0'..'9'] OF Pointer;
    Ball        : Pointer;

    White,Yellow,Red,RedFill : INTEGER;

{******************************************************************}
{*                Benutzung der CHAR-Werte :                      *}
{*                                                                *}
{* a,b,c,d,e : Felder, die abgeschossen werden knnen             *}
{* A,B,C,D,E : Felder, die bewegt werden knnen                   *}
{* 1,2,3,4,5 : Umschalter auf die jeweilige Farbe                 *}
{* #         : Wand                                               *}
{* $         : allg. Umschalter                                   *}
{* *         : Diamant                                            *}
{* +         : Todes-Feld                                         *}
{* O,o       : unterschiedliche Wnde, zwischen denen geschaltet  *}
{*             wird.                                              *}
{******************************************************************}

FUNCTION Key : INTEGER;
VAR i : INTEGER;
    Status : BYTE ABSOLUTE $0040:$0017;
BEGIN
  IF KeyPressed THEN
    BEGIN
      i := Ord(ReadKey);
      IF i <> 0 THEN Key := i
                ELSE Key := 1000+Ord(ReadKey);
    END
  ELSE
    Key := Status AND $3;
END;

PROCEDURE GetInt(st : STRING; VAR i : INTEGER;
                 Min,Max : INTEGER);
VAR Answer : STRING;
    tw,k,yy: INTEGER;
BEGIN
  SetColor(LightCyan);
  SetTextJustify(LeftText,BottomText);
  st := st + ' (+/-) : ';
  yy := GetMaxY - TextHeight('X') * 2 DIV 3;
  OutTextXY(GetMaxX DIV 3,yy,st);
  tw := GetMaxX DIV 3 + TextWidth(st) + 5;
  Str(i:3,Answer);
  OutTextXY(tw,yy,Answer);
  REPEAT
    REPEAT
      k := Key;
    UNTIL (k=13) OR (k = Ord('+')) OR (k = Ord('-'));
    CASE k OF
      Ord('+') : IF i < Max THEN Inc(i) ELSE i := Min;
      Ord('-') : IF i > Min THEN Dec(i) ELSE i := Max;
    END;
    SetFillStyle(EmptyFill,Black);
    Bar(tw,yy-TextHeight('X'),
        tw+TextWidth('000'),GetMaxY - 3);
    Str(i:3,Answer);
    OutTextXY(tw,yy,Answer);
  UNTIL k = 13;
  Bar(3,yy-TextHeight('X'),GetMaxX - 3,GetMaxY - 3);
END;

PROCEDURE Klick(Hz : INTEGER);
BEGIN
  IF Hz>Klk THEN Klk:=Hz;
END;

PROCEDURE DoKlick;
BEGIN
  IF Klk<>0 THEN
    BEGIN
      Sound(Klk); Delay(4); NoSound;
      Klk := 0
    END;
END;

PROCEDURE TakeImage(ix,iy,ax,ay : INTEGER; VAR p : Pointer);
BEGIN
  GetMem(p,ImageSize(ix,iy,ax,ay));
  GetImage(ix,iy,ax,ay,p^);
END;

PROCEDURE BothImage(ix,iy : INTEGER; VAR z; Put : INTEGER);
BEGIN
  SetActivePage(0); PutImage(ix,iy,z,Put);
  SetActivePage(1); PutImage(ix,iy,z,Put);
  SetActivePage(Page);
END;

PROCEDURE BothBar(ix,iy,ax,ay : INTEGER);
BEGIN
  SetActivePage(0); Bar(ix,iy,ax,ay);
  SetActivePage(1); Bar(ix,iy,ax,ay);
  SetActivePage(Page);
END;

PROCEDURE InitMaps;
CONST Min = 100-MStep; Max = 100+MStep;
      PP : ARRAY [1..36] OF INTEGER =
       (1,0,3,0,4,1,4,3,3,4,1,4,0,3,0,1,
        2,0,4,2,2,4,0,2,
        2,0,2,2,4,2,  0,2,2,2,2,4);
VAR   i,x,y : INTEGER;
      ch    : CHAR;
BEGIN
  SetActivePage(1);
  SetColor(White); SetLineStyle(SolidLn,0,0);
  FillChar(CM,SizeOf(CM),#0);

  x := Fx-1; y := Fy-1;
  FOR i := 1 TO 18 DO
    BEGIN
      PP[2*i-1] := PP[2*i-1]*x DIV 4;
      PP[2*i]   := PP[2*i]  *y DIV 4;
    END;

  TakeImage(0,0,x,y,CM[' ']);
  CM['O'] := CM[' '];
  Rectangle(0,0,x,y);
  TakeImage(0,0,x,y,CM['.']);
  Rectangle(4,4,x-4,y-4);
  TakeImage(0,0,x,y,CM[',']);

  FOR i := 0 TO 4 DO
    BEGIN
      SetFillStyle(StPat[i],StCol[i]);
      PutImage(0,0,CM[' ']^,NormalPut);
      FillPoly(8,PP);
      TakeImage(0,0,x,y,CM[CHAR(Ord('A')+i)]);
      PutImage(0,0,CM['.']^,NormalPut);
      Bar(1,1,x-1,y-1);
      TakeImage(0,0,x,y,CM[CHAR(Ord('a')+i)]);
      PutImage(0,0,CM[',']^,NormalPut);
      Bar(5,5,x-5,y-5);
      TakeImage(0,0,x,y,CM[CHAR(Ord('1')+i)]);
    END;

  PutImage(0,0,CM['.']^,NormalPut);
  SetColor(1); SetFillStyle(RedFill,1);
  Rectangle(0,0,x,y);
  FillPoly(4,PP[17]);
  TakeImage(0,0,x,y,CM['*']);
  SetColor(Yellow); SetFillStyle(SolidFill,Yellow);
  Rectangle(0,0,x,y);
  FillPoly(3,PP[25]); FillPoly(3,PP[31]);
  TakeImage(0,0,x,y,CM['@']);

  PutImage(0,0,CM['.']^,NormalPut);
  SetColor(Yellow);
  SetLineStyle(SolidLn,0,ThickWidth);
  Line(3,y SHR 1,x-3,y SHR 1);
  TakeImage(0,0,x,y,CM['$']);

  SetColor(White);
  PutImage(0,0,CM['.']^,NormalPut);
  Line(x SHR 1, 2, x SHR 1, y-2);
  Line(2, 2*y DIV 5, x-2, 2*y DIV 5);
  TakeImage(0,0,x,y,CM['+']);

  SetFillStyle(SolidFill,Yellow);
  Bar(0,0,x,y);
  TakeImage(0,0,x,y,CM['o']);

  SetFillPattern(Wall,White);
  SetFillStyle(UserFill,White);
  Bar(0,0,x,y);
  TakeImage(0,0,x,y,CM['=']);
  PutImage(0,0,CM[' ']^,NormalPut);

  PutImage(0,0,CM[' ']^,NormalPut);
  SetColor(White);
  SetTextStyle(DefaultFont,HorizDir,3);
  SetTextJustify(LeftText,TopText);
  OutTextXY(0,0,'0 1 2 3 4 5 6 7 8 9 ');
  x := 0; ScB := TextWidth('0');
  i := TextWidth('0 ');
  FOR y := Ord('0') TO Ord('9') DO
    BEGIN
      TakeImage(x,0,x+ScB,TextHeight(''),ScoreM[CHAR(y)]);
      Inc(x,i);
    END;
  SetFillStyle(EmptyFill,0);

  CM['.'] := NIL;
  SetLineStyle(SolidLn,0,NormWidth);
  SetFillStyle(SolidFill,White);
  SetAspectRatio(Fy,Fx);
  Bx := Fx DIV 2; By := Fy DIV 2;
  x := Bx SHR 1; y := By SHR 1;
  PieSlice(100+x,100+y,0,360,x-1);
  TakeImage(Min,Min,Max+Bx,Max+By,Ball);
  FOR x := -MStep TO MStep DO
    FOR y := -MStep TO MStep DO
      BEGIN
        PutImage(Min,Min,Ball^,NormalPut);
        PutImage(Min+x,Min+y,Ball^,XORPut);
        TakeImage(Min+x,Min+y,Max+Bx+x,Max+By+y,BallM[x,y]);
        PutImage(Min+x,Min+y,BallM[x,y]^,XORPut);
        PutImage(150,150,BallM[x,y]^,NormalPut);
      END;
  SetActivePage(0);
END;

PROCEDURE PaintBoard(Level : INTEGER);
VAR LevSt : STRING[2];
    x,y   : INTEGER;
BEGIN
  SetColor(White);
  SetLineStyle(SolidLn,$FFFF,ThickWidth);
  SetViewPort(F.ix,F.iy,F.ax,F.ay,FALSE);
  Rectangle(-2,-2,F.ax+2,F.ay+2);
  SetTextStyle(TriplexFont,HorizDir,2);
  SetTextJustify(CenterText,TopText);
  Str(Level:2,LevSt);
  OutTextXY(GetMaxX DIV 2-F.ix, -F.iy,
            Title+' - Level '+LevSt);
  SetTextJustify(LeftText, TopText);
  OutTextXY(0,F.ay+6,'Muster : ');
  M.ix := TextWidth('Muster : ') + 3;
  M.ax := M.ix + 2*Fx+2;
  M.iy := F.ay + 6;
  M.ay := M.iy+TextHeight('M');
  SetLineStyle(SolidLn,$FFFF,NormWidth);
  Rectangle(M.ix,M.iy,M.ax,M.ay);
  Sc.x := M.ax+20; Sc.y := M.iy;
  OutTextXY(Sc.x,Sc.y,'Punktzahl:');
  Inc(Sc.x,TextWidth('Punktzahl: '));
  SetTextStyle(TriplexFont,VertDir,2);
  SetTextJustify(CenterText,TopText);
  OutTextXY(-F.ix DIV 2,0,'Zeit');
  T.ix := -F.ix DIV 2 +TextHeight('');
  T.ax := -F.ix DIV 2 -TextHeight('');
  T.iy := TextWidth('Zeit ')+2;
  T.ay := F.ay-2;
  Rectangle(T.ix-1,T.iy,T.ax+1,T.ay);
  SetTextJustify(LeftText,CenterText);
  OutTextXY(F.ax+2,F.ay DIV 2,Copy);
  SetFillPattern(Wall,White);
  SetFillStyle(UserFill,White);
  Bar(0,0,F.ax,F.ay);
  DZahl := 0; FZahl := 0;
  FOR y := 0 TO FMaxY DO
    FOR x := 0 TO FMaxX DO
      IF CM[S[y,x]] <> NIL THEN
        BEGIN
          PutImage(x*Fx,y*Fy,CM[S[y,x]]^,NormalPut);
          CASE S[y,x] OF
            '*'      : Inc(DZahl);
            'a'..'e' : Inc(FZahl);
          END;
        END;
END;

PROCEDURE LevEdit;
VAR x,y,a : INTEGER;
    Back  : Pointer;
    ch    : CHAR;
BEGIN
  SetGraphMode(GetGraphMode);
  S     := Lev.Back[Level];
  Style := Lev.Sty[Level];
  Bx    := Lev.Cx[Level];
  By    := Lev.Cy[Level];
  CM['O'] := CM[',']; CM[','] := NIL;
  CM['#'] := CM['=']; CM['='] := NIL;
  PaintBoard(Level);
  SetWriteMode(XORPut);
  SetLineStyle(SolidLn,$FFFF,0);
  SetFillStyle(StPat[Style],StCol[Style]);
  Bar(M.ix+1,M.iy+1,M.ax-1,M.ay-1);
  x := 0; y := 0;
  PutImage(Bx*Fx,By*Fy,Ball^,NormalPut);
  REPEAT
    Line(Fx*x,Fy*y,Fx*(x+1),Fy*(y+1));
    Line(Fx*(x+1),Fy*y,Fx*x,Fy*(y+1));
    REPEAT
      a := Key; ch := CHAR(a);
    UNTIL a > 2;
    IF ch = 'q' THEN ch := '*';
    Line(Fx*x,Fy*y,Fx*(x+1),Fy*(y+1));
    Line(Fx*(x+1),Fy*y,Fx*x,Fy*(y+1));
    IF (a>= 1071) AND (a<=1081) THEN
      BEGIN
        x := (FMaxX+x+((a-1071) MOD 4)) MOD (FMaxX+1);
        y := (FMaxY+y+((a-1071) DIV 4)) MOD (FMaxY+1);
      END;
    IF a=Ord('/') THEN
      BEGIN
        FillChar(S,SizeOf(S),' ');
        SetFillStyle(SolidFill,0);
        Bar(0,0,F.ax,F.ay);
        x  := 0; y  := 0; ch := '.';
        Bx := 0; By := 0;
      END;
    IF (a < 128) AND (CM[ch] <> NIL) THEN
      IF (x <> Bx) OR (y <> By) THEN
        BEGIN
          S[y,x] := ch;
          IF (ch >= '1') AND (ch <= '5') THEN
            BEGIN
              Style := Ord(ch)-Ord('1');
              SetFillStyle(StPat[Style],StCol[Style]);
              Bar(M.ix+1,M.iy+1,M.ax-1,M.ay-1);
            END;
          PutImage(Fx*x,Fy*y,CM[ch]^,NormalPut);
        END;
    IF (ch = '.') AND (S[y,x] = ' ') THEN
      BEGIN
        PutImage(Bx*Fx,By*Fy,Ball^,XORPut);
        Bx := x; By := y;
        PutImage(Bx*Fx,By*Fy,Ball^,NormalPut);
      END;
  UNTIL a = 27;
  CM[','] := CM['O']; CM['O'] := CM[' '];
  CM['='] := CM['#']; CM['#'] := NIL;
  Lev.Back[Level] := S;
  Lev.Sty[Level]  := Style;
  Lev.Cx[Level]   := Bx;
  Lev.Cy[Level]   := By;
END;

PROCEDURE NewScore(Add : INTEGER);
CONST OScore : STRING[6] = '';
VAR   i  : WORD;
      st : STRING[6];
BEGIN
  IF Add=0 THEN OScore:= '      ';
  Inc(Score,Add); Str(Score:6,st);
  FOR i := 1 TO 6 DO
    BEGIN
      IF st[i] = ' ' THEN st[i] := '0';
      IF st[i] <> OScore[i] THEN
        BothImage(Sc.x+ScB*(i-1),Sc.y,ScoreM[st[i]]^,NormalPut);
    END;
  OScore := st;
END; (* NewScore *)

PROCEDURE ChangeWall;
VAR x,y : INTEGER;
    ch  : CHAR;
BEGIN
  IF CCount <> 0 THEN Klick(3000);
  CCount := 80+Random(200);
  IF S[By DIV 2,Bx DIV 2] <> ' ' THEN Exit;
  Page := (Page+1) MOD 2;
  PutImage(ScX,ScY,Ball^,XORPut);
  SetActivePage(Page);
  PutImage(ScX,ScY,Ball^,XORPut);
  SetVisualPage(Page);
  IF ClrO = 'o' THEN ClrO := 'O'
                ELSE ClrO := 'o';
END;

FUNCTION Bang(x,y,dx,dy : INTEGER) : BOOLEAN;
VAR F,fn : CHAR;
    i    : INTEGER;
BEGIN
  IF (x<0) OR (y<0) OR (x>BMaxX) OR (y>BMaxY) THEN
    BEGIN
      Klick(220); Bang := TRUE; Exit;
    END;
  x := x SHR 1; y := y SHR 1; F := S[y,x];
  IF (F = ' ') OR (F = ClrO) THEN
    Bang := FALSE
  ELSE BEGIN
    Bang := TRUE;
    IF (F>='1') AND (F<='5') THEN BEGIN
      IF FZahl > 0 THEN BEGIN
        Style := Ord(F) - Ord('1');
        DelF  := Chr(Style+Ord('a'));
        MoveF := Chr(Style+Ord('A'));
        HMoveF:= Chr(Style+128);
        LMoveF:= Chr(Style+160);
        SetFillStyle(StPat[Style],StCol[Style]);
        BothBar(M.ix+1,M.iy+1,M.ax-1,M.ay-1);
      END;
      ChangeWall;
    END ELSE IF (F='+') THEN BEGIN
      Dead := TRUE; Score := 0;
      FOR i := 0 TO 200 DO BEGIN
        Sound(2000-10*i); Delay(4);
      END;
      NoSound; Delay(100);
    END ELSE IF (F='$') THEN BEGIN
      ChangeWall
    END ELSE IF (F=DelF) THEN BEGIN
      S[y,x] := ' ';
      BothImage(Fx*x,Fy*y,CM[' ']^,0);
      IF DelF='@' THEN BEGIN
        Dec(DZahl);
	NewScore(300);
        Klick(1000);
      END ELSE BEGIN
        Dec(FZahl);
        Klick(1000);
      END;
    END
  ELSE IF (F = MoveF) OR (F = HMoveF) OR (F=LMoveF) THEN BEGIN
    Inc(y,dy); Inc(x,dx); fn := S[y,x];
    IF (y>=0) AND (y<=FMaxY) AND
       (x>=0) AND (x<=FMaxX) AND
       ((dx=0) OR (dy=0)) AND
       ((fn = ' ') OR (fn = ClrO))
    THEN BEGIN
      CASE fn OF
        ' ' : S[y,x] := MoveF;
        'O' : S[y,x] := HMoveF;
        'o' : S[y,x] := LMoveF;
      END;
      BothImage(Fx*x,Fy*y,CM[MoveF]^,0);
      Dec(x,dx); Dec(y,dy);
      IF F = MoveF THEN BEGIN
        S[y,x] := ' ';
        BothImage(Fx*x,Fy*y,CM[' ']^,0);
      END ELSE IF F = HMoveF THEN BEGIN
        S[y,x] := 'O';
        SetActivePage(1);
        PutImage(Fx*x,Fy*y,CM['o']^,0);
        SetActivePage(0);
      END ELSE BEGIN
        S[y,x] := 'o';
        SetActivePage(0);
        PutImage(Fx*x,Fy*y,CM['o']^,0);
        SetActivePage(1);
      END;
      PutImage(Fx*x,Fy*y,CM[' ']^,0);
      SetActivePage(Page);
      Klick(440);
    END ELSE Klick(220)
  END ELSE
    Klick(220);
  END;
END; (* Bang *)

FUNCTION Game : BOOLEAN;
CONST Left   = #2;
      Right  = #1;
      Esc    = #27;
VAR   i,dx,dy,nx,ny   : INTEGER;
      OldScore        : LONGINT;
BEGIN
  CCount := 80+Random(200);
  Game   := FALSE;
  S      := Lev.Back[Level];
  Style  := Lev.Sty[Level];
  Bx     := Lev.Cx[Level];
  By     := Lev.Cy[Level];
  ClrO   := 'O';
  ScX := Fx*Bx-4; ScY := Fy*By-4;
  SetGraphMode(GetGraphMode);
  SetVisualPage(0);
  CM['?'] := CM['o']; CM['o'] := CM['O']; CM['O'] := CM['?'];
  SetActivePage(1); PaintBoard(Level);
  SetVisualPage(1);
  CM['?'] := CM['o']; CM['o'] := CM['O']; CM['O'] := CM['?'];
  SetActivePage(0); PaintBoard(Level);
  SetVisualPage(0);
  PutImage(ScX,ScY,Ball^,XORPut);
  Page      := 0;
  Dead      := FALSE;
  OldScore  := Score;
  TLine     := T.iy;
  Time      := MaxTime;
  TCheck    := MaxTime;
  SetFillStyle(SolidFill,White);
  BothBar(T.ix,T.iy-1,T.ax,T.ay+1);
  SetFillStyle (StPat[Style],StCol[Style]);
  BothBar (M.ix+1,M.iy+1,M.ax-1,M.ay-1);
  NewScore(0);
  MoveF  := Chr(Style+Ord('A'));
  HMoveF := Chr(Style+128);
  LMoveF := Chr(Style+160);
  DelF   := Chr(Style+Ord('a'));
  Bx := 2*Bx; By := 2*By;
  dx := 0;    dy := -1;

  REPEAT
    i := Key;
    IF i < 256 THEN CASE CHAR(i) OF
      Left     : dx := -1;
      Right    : dx := +1;
      Esc      : BEGIN
                   Score := OldScore; Exit;
                 END;
      '0'..'9' : Speed  := i-Ord('0');
    END;
    IF CCount = 0 THEN
      ChangeWall
    ELSE
      Dec(CCount);
    IF (dx <> 0) AND Bang(Bx+dx,By,dx,0)
      THEN nx := -dx
      ELSE nx := dx;
    IF Bang(Bx,By+dy,0,dy)
      THEN ny := -dy
      ELSE ny := dy;
    IF (nx=dx) AND (ny=dy) AND Bang(Bx+dx,By+dy,dx,dy)
    THEN
      nx := -dx;
    IF Dead THEN Exit;
    IF FZahl = 0 THEN
      BEGIN
        FZahl := -1;
        DelF  := '@';
        FOR i := 8 TO 12 DO
          BEGIN
            Sound(100*i); Delay(40); NoSound;
          END;
        FOR dy := 0 TO FMaxY DO
          FOR dx := 0 TO FMaxX DO
            IF S[dy,dx] = '*' THEN BEGIN
              S[dy,dx] := '@';
              BothImage(Fx*dx,Fy*dy,CM['@']^,0);
            END;
      END;
    DoKlick;
    FOR i := 1 TO SprMax DO BEGIN
      dx := SprX[i]*nx;
      dy := SprY[i]*ny;
      Inc(ScX,dx); Inc(ScY,dy);
      PutImage(ScX,ScY,BallM[dx,dy]^,XORPut);
      Delay(20-2*Speed);
    END;
    IF Time > 0 THEN Dec(Time,22-2*Speed)
                ELSE Time := 0;
    IF Time < TCheck THEN BEGIN
      SetColor(0);
      SetFillStyle(EmptyFill,0);
      BothBar(T.ix-1,TLine,T.ax+1,TLine);
      Inc(TLine);
      TCheck := LONGINT(MaxTime) * (T.ay-TLine)
                      DIV (T.ay-T.iy);
    END;
    Inc(Bx,nx); Inc(By,ny);
    dx := 0; dy := ny;
  UNTIL (DZahl = 0);
  WHILE (Time > 0) DO BEGIN
    NewScore(25); Dec(Time,MaxTime*25 DIV 1000);
    Klick(220); DoKlick; Delay(7);
  END;
  Delay(50);
  FOR i := 2 TO 5 DO BEGIN
    Sound(100*i); Delay(250);
  END;
  NoSound;
  Game := TRUE;
  Delay(500);
END; (* Game *)

FUNCTION IntStr(i : LONGINT; Nr : INTEGER) : STRING;
VAR h : STRING;
BEGIN
  Str(i:Nr,h);
  Nr := 1;
  WHILE h[Nr] = ' ' DO BEGIN
    h[Nr] := '0'; Inc(Nr);
  END;
  IntStr := h;
END; (* IntStr *)

PROCEDURE Abort(Message : STRING);
BEGIN
  WriteLn(Message, ^G);
  Halt(2);
END;

VAR Driver, Mode          : INTEGER;
    n,ppx,px,py,dx,dy,way : INTEGER;
    ch                    : CHAR;
CONST
  NoGrafics = 'Konnte Grafik nicht initialisieren!';

BEGIN
  Randomize;
  DetectGraph(Driver, Mode);
{$IFDEF BGILINK}
{ bedingte Compilierung: BGI-Treiber und Vektorfont linken }
  CASE Driver OF
    EGA,
    VGA:      IF RegisterBGIDriver(@EGAVGADriverProc) < 0 THEN
                Abort(NoGrafics);
    HercMono: IF RegisterBGIDriver(@HercDriverProc) < 0 THEN
                Abort(NoGrafics);
  ELSE
    Abort('PingBall bentigt eine EGA-, VGA- oder Hercules-' +
          'Grafikkarte!');
  END;
  IF RegisterBGIFont(@TriplexFontProc) < 0 THEN
    Abort('Konnte Vektorschrift nicht initialisieren!');
{$ELSE}
  IF NOT Driver IN [HercMono, EGA, VGA] THEN
    Abort('PingBall bentigt eine EGA-, VGA- oder Hercules-' +
          'Grafikkarte!');
{$ENDIF}
  InitGraph(Driver, Mode, GetEnv('BGIPATH'));
  IF GraphResult <> 0 THEN
    Abort(NoGrafics);
  SetGraphMode(1);
  White := GetMaxColor;
  IF White = 1 THEN BEGIN
    Yellow  := 1;
    RedFill := WideDotFill;
    StCol   := StBW;
  END ELSE BEGIN
    Yellow := White-1;
    RedFill := SolidFill;
  END;

  SetTextStyle(TriplexFont,HorizDir,3);
  px := TextHeight('M');
  SetTextStyle(TriplexFont,VertDir,3);
  py := TextHeight('M');
  F.ix := (7*px) DIV 2; F.ax := GetMaxX-px;
  F.iy := (3*py) DIV 2; F.ay := GetMaxY-F.iy;
  Fx   := ((F.ax-F.ix) DIV (FMaxX+1)) AND $FFFC;
  Fy   := ((F.ay-F.iy) DIV (FMaxY+1)) AND $FFFC;
  F.ax := (FMaxX+1)*Fx-1; F.ay := (FMaxY+1)*Fy-1;
  dx := 0; dy := 0;
  SprX[0] := 0; SprY[0] := 0;
  FOR way := 1 TO SprMax DO BEGIN
    px := (way*Fx DIV 2) DIV SprMax;
    SprX[way] := px-dx; dx := px;
    py := (way*Fy DIV 2) DIV SprMax;
    SprY[way] := py-dy; dy := py;
  END;
  SetTextStyle(TriplexFont,HorizDir,10);
  SetTextJustify(CenterText,CenterText);
  FOR n := 1 TO 80 DO BEGIN
    IF GetMaxColor > 1 THEN
      SetColor((n DIV 3) MOD GetMaxColor)
    ELSE
      SetColor(BYTE(Odd(n)));
    SetUserCharSize(n, 16, n, 16);
    SetTextJustify(LeftText,CenterText);
    OutTextXY(10,n*2,'Ping');
    SetTextJustify(RightText,CenterText);
    OutTextXY(GetMaxX-10,n*2,'Ball');
  END;
  SetColor(White);
  SetTextJustify(LeftText,CenterText);
  OutTextXY(10,n*2,'Ping');
  SetTextJustify(RightText,CenterText);
  OutTextXY(GetMaxX-10,n*2,'Ball');
  InitMaps;
  SetColor(White);
  SetTextStyle(TriplexFont,HorizDir,3);
  SetTextJustify(RightText,BottomText);
  OutTextXY(GetMaxX,GetMaxY,'Taste drcken...');
  px := Fx; py := GetMaxY DIV 2;
  dx := 1; dy := 1;
  PutImage(px,py,Ball^,XORPut);
  way := 0;
  Klk := 0;
  REPEAT
    IF Random(600-way) = 0 THEN BEGIN
      way := 0;
      dx := INTEGER(Random(3))-1;
      dy := 2*INTEGER(Random(2))-1;
      Klick(1000);
    END ELSE Inc(way);
    IF px >= GetMaxX-Fx THEN BEGIN
      Klick(220);
      dx := -1;
    END ELSE IF px <= 1 THEN BEGIN
      Klick(220);
      dx := 1;
    END;
    IF py >= GetMaxY-Fy-6 THEN BEGIN
      Klick(220);
      dy := -1;
    END ELSE IF py <= 1 THEN BEGIN
      Klick(220);
      dy := 1;
    END;
    DoKlick;
    Inc(px,2*dx); Inc(py,2*dy);
    Delay(1);
    PutImage(px,py,BallM[2*dx,2*dy]^,XORPut);
  UNTIL KeyPressed;
  px := Key;

  Speed := 5; Level := 1; Score := 0;
  Assign(FLevel,'PINGBALL.PBL');
  (*$I-*) Reset(FLevel); (*$I+*)
  IF IOResult <> 0 THEN BEGIN
    RestoreCrtMode;
    WriteLn('Leveldatei nicht gefunden...');
    Halt;
  END;
  Read(FLevel,Lev);
  ch := ' ';
  REPEAT
    SetVisualPage(0);
    SetActivePage(0);
    IF NOT (ch IN ['L','S','!']) THEN BEGIN
      SetGraphMode(GetGraphMode);
      SetTextStyle(TriplexFont,HorizDir,6);
      SetTextJustify(CenterText,TopText);
      way := 3*TextHeight('X') DIV 2;
      SetColor(Yellow);
      OutTextXY(GetMaxX DIV 2,0,Title);
      SetTextStyle(TriplexFont,HorizDir,3);
      SetColor(LightRed);
      OutTextXY(GetMaxX DIV 2,way,Copy);
      py := TextHeight('X');
      way := way + 2 * py;
      px := GetMaxX DIV 2;
      SetLineStyle(SolidLn,0,ThickWidth);
      SetColor(Green);
      Line(0,way+4*py,GetMaxX,way+4*py);
      Rectangle(0, 0, GetMaxX, GetMaxY);
      SetColor(LightGreen);
      SetTextJustify(RightText,TopText);
      OutTextXY(px,     way,'Level : ');
      OutTextXY(px,  way+py,'Speed : ');
      OutTextXY(px,way+2*py,'Score : ');
      SetColor(White);
      SetTextJustify(LeftText,TopText);
      OutTextXY(px,way+2*py,IntStr(Score,6));
      SetTextJustify(CenterText, TopText);
      SetColor(Yellow);
      OutTextXY(GetMaxX DIV 2,
                way+5*py,'<L>evel setzen, <S>peed setzen');
      OutTextXY(GetMaxX DIV 2,
                way+6*py,'<E>ditor, <!> speichern');
      OutTextXY(GetMaxX DIV 2,
                way+7*py,'<Q>uit, <Space> oder <Return> zum Spielanfang');
    END;
    SetFillStyle(EmptyFill,Black);
    Bar(px,way,px+TextWidth('000'),way+py+TextHeight(' '));
    SetTextJustify(LeftText,TopText);
    SetColor(White);
    OutTextXY(px,     way,IntStr(Level,2));
    OutTextXY(px,  way+py,IntStr(Speed,2));
    REPEAT
      REPEAT ppx := Key UNTIL (ppx>2) AND (ppx<127);
      ch := UpCase(CHAR(ppx));
    UNTIL ch IN  [#13,#27,'Q',' ','!','E','L','S'];
    CASE ch OF
      #13,' ' : WHILE Game AND (Level<50) DO BEGIN
                  ch := ' ';
                  Inc(Level);
                END;
      '!'     : BEGIN
                  ReWrite(FLevel);
                  Write(FLevel,Lev);
                  Close(FLevel);
                END;
      'E'     : BEGIN
                  LevEdit;
                  ch := ' ';
                END;
      'L'     : GetInt('Level',Level,1,50);
      'S'     : GetInt('Speed',Speed,0,9);
    END;
  UNTIL ch IN ['Q', #27];
  RestoreCrtMode;
END.
(* ------------------------------------------------------ *)
(*               Ende von PINGBALL.PAS                    *)
