(* ------------------------------------------------------ *)
(*                    TOOLBOX.PAS                         *)
(*       (c) 1991 Andreas Schallmaier & TOOLBOX           *)
(* ------------------------------------------------------ *)
PROGRAM Toolbox;

USES
  WObjects,
  WinTypes,
  WinProcs,
  Strings,
  StdDlgs,
  WinDos;

{$R Toolbox1.RES}

CONST
  cm_About  = 110;
  cm_Open   = 120;
  cm_Save   = 121;
  cm_SaveAs = 122;

TYPE
  TMyApplication = OBJECT(TApplication)
    FirstApp : BOOLEAN;
    PROCEDURE InitMainWindow;  VIRTUAL;
    PROCEDURE InitApplication; VIRTUAL;
  END;

  PMyWindow = ^TMyWindow;
  TMyWindow = OBJECT(TWindow)
    FileName : ARRAY[0..fsPathName] OF CHAR;
    CONSTRUCTOR Init(AParent : PWindowsObject;
                     ATitle  : PChar);
    PROCEDURE WMLButtonDown(VAR Msg : TMessage);
    VIRTUAL wm_First+wm_LButtonDown;

    PROCEDURE WMRButtonDown(VAR Msg : TMessage);
    VIRTUAL wm_First+wm_RButtonDown;

    PROCEDURE cmAbout(VAR Msg : TMessage);
    VIRTUAL cm_First+cm_About;

    PROCEDURE cmOpen(VAR Msg : TMessage);
    VIRTUAL cm_First+cm_Open;

    PROCEDURE cmSave(VAR Msg : TMessage);
    VIRTUAL cm_First+cm_Save;

    PROCEDURE cmSaveAs(VAR Msg : TMessage);
    VIRTUAL cm_First+cm_SaveAs;
  END;

(* --- TMyApplication ----------------------------------- *)

  PROCEDURE TMyApplication.InitMainWindow;
  BEGIN
    IF FirstApp THEN
      MainWindow := NEW(PMyWindow,
      Init(NIL, 'Toolbox Applikation 1 - Erste Instanz'))
    ELSE
      MainWindow := NEW(PMyWindow,
      Init(NIL, 'Toolbox Applikation 1 - Weitere Instanz'));
  END;

  PROCEDURE TMyApplication.InitApplication;
  BEGIN
    FirstApp := TRUE;
  END;

  (* --- TMyWindow -------------------------------------- *)

  CONSTRUCTOR TMyWindow.Init(AParent : PWindowsObject;
                             ATitle  : PChar);
  BEGIN
    TWindow.Init(AParent, ATitle);
    Attr.Menu := LoadMenu(HInstance, PChar(100));
  END;

  PROCEDURE TMyWindow.WMLButtonDown(VAR Msg : TMessage);
  CONST
    r = 10;
  VAR
    DC    : HDC;
    Dummy : Bool;
  BEGIN
    DC := GetDC(HWindow);
    Dummy := Ellipse(DC, Msg.LParamLo-r, Msg.LParamHi-r,
                     Msg.LParamLo+r, Msg.LParamHi+r);
    ReleaseDC(HWindow, DC);
  END;

  PROCEDURE TMyWindow.WMRButtonDown(VAR Msg : TMessage);
  BEGIN
    InvalidateRect(HWindow, NIL, TRUE);
  END;

  PROCEDURE TMyWindow.cmAbout(VAR Msg : TMessage);
  VAR
    Dialog : TDialog;
  BEGIN
    Dialog.Init(@Self, PChar(200));
    Dialog.Execute;
    Dialog.Done;
  END;

  PROCEDURE TMyWindow.cmOpen(VAR Msg : TMessage);
  BEGIN
    IF (Application^.ExecDialog(NEW(PFileDialog,
        Init(@Self, PChar(sd_FileOpen),
             StrCopy(FileName, '*.PAS')))) = id_Ok) THEN
      MessageBox(HWindow, FileName,
                 'Angewhlte Datei :', mb_Ok);
  END;

  PROCEDURE TMyWindow.cmSave(VAR Msg : TMessage);
  BEGIN
    MessageBox(HWindow, 'Noch nicht eingebaut !',
                        'Schwupp !', mb_Ok);
  END;

  PROCEDURE TMyWindow.cmSaveAs(VAR Msg : TMessage);
  BEGIN
    IF (Application^.ExecDialog(NEW(PFileDialog,
        Init(@Self, PChar(sd_FileSave),
             StrCopy(FileName, '*.PAS')))) = id_Ok) THEN
      MessageBox(HWindow, FileName,
                 'Angewhlte Datei :', mb_Ok);
  END;

(* --- Hauptprogramm------------------------------------- *)

VAR
  MyApp : TMyApplication;

BEGIN
  MyApp.Init('TestApp');
  MyApp.Run;
  MyApp.Done;
END.
(* ------------------------------------------------------ *)
(*                Ende von TOOLBOX.PAS                    *)


