(* ------------------------------------------------------ *)
(*                     TVPLUS.PAS                         *)
(*             Dialogobjekte fr Turbo Vision             *)
(*       (c) 1991  Dieter Schmalstieg & TOOLBOX           *)
(* ------------------------------------------------------ *)
UNIT TVplustb;

INTERFACE

USES StrFunc, Objects, Views, Drivers, Dialogs;

TYPE
  TLongint = OBJECT(TInputLine)
    newsel : BOOLEAN;

    CONSTRUCTOR Init(VAR bounds : TRect; amaxlen : INTEGER);
    DESTRUCTOR  Done;                               VIRTUAL;
    FUNCTION    DataSize : WORD;                    VIRTUAL;
    PROCEDURE   Draw;                               VIRTUAL;
    PROCEDURE   GetData(VAR rec);                   VIRTUAL;
    PROCEDURE   HandleEvent(VAR event : TEvent);    VIRTUAL;
    PROCEDURE   SetData(VAR rec);                   VIRTUAL;
    PROCEDURE   Select;                             VIRTUAL;
  END;
  PLongint = ^TLongint;

IMPLEMENTATION

  CONSTRUCTOR TLongint.Init;
  BEGIN
    TInputLine.Init(bounds, amaxlen);
    Data^ := Copy('          ', 1, amaxlen-1)+'0';
    SelEnd := 0;
    newsel := TRUE;
  END;

  PROCEDURE TLongint.Select;
  BEGIN
    TInputLine.Select;
    newsel := TRUE;
  END;

  DESTRUCTOR TLongint.Done;
  BEGIN
    TInputLine.Done;
  END;

  FUNCTION TLongint.DataSize : WORD;
  BEGIN
    DataSize := SizeOf(LONGINT);
  END;

  PROCEDURE TLongint.Draw;
  VAR
    i : INTEGER;
  BEGIN
    IF (State AND sfSelected) = 0 THEN newsel := TRUE;
    IF newsel AND(Data^[maxlen] = ' ') THEN
      Data^[maxlen] := '0';
    SelEnd := 0;
    IF newsel THEN SelEnd := maxlen;
    CurPos := maxlen-1;
    TInputLine.Draw;
  END;

  PROCEDURE TLongint.GetData(VAR rec);
  VAR
    l : LONGINT;
  BEGIN
    l := ValL(Data^);
    Move(l, rec, SizeOf(l));
  END;

  PROCEDURE TLongint.HandleEvent(VAR event : TEvent);
  VAR
    i : INTEGER;
  BEGIN
    TView.HandleEvent(event);
    CASE event.What OF
      evKeyDown :
        BEGIN
          IF (event.CharCode IN['0'..'9']) THEN BEGIN
            IF newsel THEN BEGIN
              newsel := FALSE;
              FOR i := 1 TO maxlen DO Data^[i] := ' ';
            END;
            IF Data^[1] = ' ' THEN BEGIN
              FOR i := 1 TO maxlen-1 DO
                Data^[i] := Data^[i+1];
              Data^[maxlen] := event.CharCode;
            END;
            Draw;
            ClearEvent(event);
          END;
          IF (event.KeyCode = kbBack) THEN BEGIN
            newsel := FALSE;
            FOR i := maxlen DOWNTO 2 DO
              Data^[i] := Data^[i-1];
            Data^[1] := ' ';
            Draw;
            ClearEvent(event);
          END;
        END;            (* evkeydown *)
    END;              (* case what *)
  END;

  PROCEDURE TLongint.SetData(VAR rec);
  BEGIN
    Data^ := Strl(LONGINT(rec), maxlen);
  END;

END.
(* ------------------------------------------------------ *)
(*                   Ende von TVPLUS.PAS                  *)
