(* ------------------------------------------------------ *)
(*                       DEMO.PAS                         *)
(*                                                        *)
(* Sprache : Turbo Pascal Version 5.50                    *)
(*                                                        *)
(* Demonstriert die Anwendung von GRWRITE.PAS.            *)
(*                                                        *)
(* Das Programm bentigt den fr die jeweilige Grafik-    *)
(* karte passenden BGI-Treiber!                           *)
(*                                                        *)
(*              1991       Ralf Homburg                   *)
(* ------------------------------------------------------ *)

uses
  Crt,
  Graph,
  GrWrite;

var
  Ch       : char;
  I,
  grDriver,
  grMode,
  ErrCode  : integer;

begin
  grDriver := Detect;          { Grafik initialisieren ... }
  InitGraph(grDriver,grMode,'C:\TP');
  ErrCode := GraphResult;
  if ErrCode = grOk then
  begin
    InstallGraphWrite;     { Grafik-Write(Ln) installieren }
    ClearDevice;                   { Ein paar Ausgaben ... }
    MoveTo(0,10);
    SetTextStyle(DefaultFont,HorizDir,3);
    writeln(' Write(Ln) im Grafikmodus');
    writeln;
    SetTextJustify(CenterText,TopText);
    MoveTo(GetMaxX div 2,GetY);
    HorizLineSpacing := 5;
    for I := 1 to 4 do
    begin
      SetTextStyle(DefaultFont,HorizDir,I);
      writeln('Treiber: ',grDriver,' Modus: ',grMode);
    end;
    Ch := readkey;
    ClearDevice;
    SetTextJustify(LeftText,CenterText);
    SetTextStyle(DefaultFont,VertDir,1);
    MoveTo(80,GetMaxY div 2);
    for I := 1 to 25 do
    begin
      VertLineSpacing := I;
      writeln('WriteLn senkrecht');
    end;
    Ch := readkey;
    CloseGraph;                         { Grafik schlieen }
    InstallCrtWrite;     { Text-Write(Ln) installieren !!! }
    writeln('WriteLn wieder im Textmodus.');
    Ch := readkey;
  end
  else
    writeln('Grafikfehler:',GraphErrorMsg(ErrCode));
end.
